#!/usr/bin/perl

use lib '.';
use warnings;
use strict;

use POE::Kernel;
use POE::Session::SubVar;

POE::Session::SubVar->create(
    inline_states => {
	_start => sub {
	    warn "\@_: @_";
	    kernel->yield('count' => 1);
	},
	count => sub {
	    my ($count) = @_;
	    print "counted to $count\n";
	    kernel->yield(count => ++$count)  if $count < 10;
	},
	_stop => sub { warn "done" },
    },
    args => [qw(foo bar baz)],
);

$poe_kernel->run();

1;
__END__
